#include <mbed.h>

enum INPUT_BUTTON
{
    eUp,
    eDown,
    eLeft,
    eRight,
    eCircle,
    eSquare,
    eLastButton,
};

#define BUTTON_DEBOUNCE_TICKS   3

class input
{
public:

    input();
    virtual ~input() {};
    
    void tick();        // Call this function at regular intervals (preferably the frame rate)
    
    // Buttons
    int hit(INPUT_BUTTON button);
    bool pressed(INPUT_BUTTON button);
    void clear();
    
    // Accelerometer
    // X,Y,Z (0 to 100)
    int accel_x();
    int accel_y();
    int accel_z();
    // Roll,Pitch (0 to 359)
    int accel_roll();
    int accel_pitch();
    
protected:

    DigitalIn left;
    DigitalIn right;
    DigitalIn down;
    DigitalIn up;
    DigitalIn square;
    DigitalIn circle;
    int m_iPressedTicks[eLastButton];
    int m_iHitCount[eLastButton];
    void dobutton(INPUT_BUTTON button, bool bPressed);

    static const char I2C_ADDR = 0x1C << 1;
    I2C i2c;
    void accelReadRegisters(char address, char* buffer, int len);
    int accelWriteRegister(char address, char value);
    float accelConvert(char* buffer);
    
    float m_fAccelX;
    float m_fAccelY;
    float m_fAccelZ;
};
