#include "mbed.h"

class led_state
{
public:
    
    led_state();
    virtual ~led_state() {};
    
    bool tick();
    
    void set(bool on, int ticks = -1);
    void blink(int rate, int state = 1, int ticks = -1);

    enum LED_MODE
    {
        eLEDOff,
        eLEDOn,
        eLEDBlink,
    } m_eMode;
    
    int m_iValue;
    int m_iTicks;
    int m_iRate;
    int m_iCounter;
    
};

class led
{
public:
    
    led();
    virtual ~led() {};
    
    void tick();        // call at about 50 Hz
    
    // Set, Get, Blink, etc...
    bool get(int led);
    void set(int led, bool on, int ticks = -1);      // ticks == -1 => infinite
    void blink(int led, int rate, int state = 1, int ticks = -1);    // rate in ticks, ticks == -1 => infinite
    
protected:
    
    led_state led_state1, led_state2;
    DigitalOut led1;
    DigitalOut led2;
    
};